//使用模块路径进行导入， module_learn 代表的是这个lib的名字。 level0_mod1代表是这个lib下的模块
use module_learn::level0_mod1;
//使用{}可以一次性导入多个模块/函数等，不必多行
use module_learn::level0_mod1::{levl1_mod2, func};
use module_learn;

use module_learn::tree0_mod1;
//如果导入时存在重名的，可以使用as关键字起一个别名去辨别。
use std::io::Result  as ioResult;
use std::fmt::Result  as fmtResult;

fn main() {
    println!("Hello, world!");
    level0_mod1::func();
    func();
    levl1_mod2::func();

    module_learn::func();

    tree0_mod1::func();
}
