//定义一个public的函数，可以暴露给外部调用
pub fn func(){
    println!("This is tree0_mod1::func");
    //fun1属于本模块内的私有函数。模块内的code 是可以使用的，
    fun1();
    tree1_mod1::func();
    //tree1_mod1::fun1是私有的，只能在tree1_mod1 子模块内使用。
    //tree1_mod1::fun1();

    //tree2_mod1 是私有的只能在 tree1_mod2 模块内使用。不能被更外部的code使用
    //tree1_mod2::tree2_mod1::func();
}
//定义一个私有的函数。外部不能直接使用，只能模块内部的code可以使用
fn fun1() {
    println!("This is tree0_mod1::func1");
    tree1_mod1::func();
}

//定义一个私有的模块，。只能被同级的其他模块及其子模块调用，不能被外部的code调用
mod tree1_mod1;

//定义一个公共的子模块。由于其父模块也是public的所以其可以被外部的code进行调用
pub mod tree1_mod2;